% ----------------------------------------------------------------------
% System:	ECLiPSe Constraint Logic Programming System
% Copyright (C) Imperial College London and ICL 1995-1999
% Version:	$Id: apply.pl,v 1.2 1999/08/07 15:49:59 js10 Exp $
% ----------------------------------------------------------------------

%
% SEPIA PROLOG LIBRARY MODULE
%
% sccsid("%W%             %E%").
% sccscr("%Z%  Copyright 1991 ECRC GmbH ").
%
% IDENTIFICATION:       apply.pl
%
% AUTHOR:               Joachim Schimpf
%
% CONTENTS:             apply/2,3
%

:- module(apply).
:- global apply/2.
:- export apply/3.

:- tool(apply/2, apply/3).

apply(Term, AddArgs, Module) :-
	( atom(Term) ->
	    Goal =.. [Term|AddArgs]
	;
	    Term =.. List,
	    append(List, AddArgs, NewList),
	    Goal =.. NewList
	),
	call(Goal, Module).

