%
% This file tells lib(eplex) what optimizer version to expect
% on a particular machine. Add lines of the form:
%
%	licence(Hostname, Solver, Version, LicStr, LicNum).
% E.g.
%	licence('cow.ic.ac.uk',  cplex, '50', '', 0).	% CPLEX Version 5.0
%	licence('breeze',       xpress, '10', '', 0).	% XPRESS-MP Version 10
%
% The hostname must match the result of get_flag(hostname,H),
% converted to an atom. On some machines, this is just a name,
% on others it is the complete internet domain name.
%
% The meaning of LicStr and LicNum depends on the optimizer:
%
% CPLEX:
%	LicStr:	environment settings for runtime licences, e.g.
%			"CPLEXLICENSE=/usr/local/cplexlic.ptr"
%	LicNum:	serial number for runtime licences
%
% XPRESS-MP:
%	LicStr:	directory where .pwd and .msg files are located
%			(overrides value of XPRESS environment variable)
%	LicNum:	unused
%
% If a machine has both optimizers and lib(eplex) is called (rather than
% lib(eplex_cplex) or lib(eplex_xpress)) the first one will be loaded.
%

licence('triumph.icparc.ic.ac.uk', cplex, '40', '', 0).
licence(breeze, cplex, '50', '', 0).
licence(breeze, xpress, '11', '/usr/local/eclipse/xosl11b/sparc_sunos5', 0).
licence(tempest, cplex, '60', '', 0).
licence(tempest, xpress, '11', '/usr/local/eclipse/xosl11b/sparc_sunos5', 0).
licence('horse.icparc.ic.ac.uk', cplex, '60', '', 0).
licence('pig.icparc.ic.ac.uk', cplex, '60', '', 0).
licence('sheep.icparc.ic.ac.uk', cplex, '60', '', 0).
licence('cow.icparc.ic.ac.uk', cplex, '60', '', 0).
licence('dog.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('cat.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('hen.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('chicken.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('goose.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('turkey.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('turkey.icparc.ic.ac.uk', xpress, '11', '/usr/local/eclipse/xosl11b/i386_linux', 0).
licence('goat.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('salmon.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('ox.icparc.ic.ac.uk', cplex, '65', '', 0).
licence('ostrich.icparc.ic.ac.uk', cplex, '65', '', 0).
licence(perivale, xpress, '11', 'M:\\Eclipse\\xosl11b\\i386_nt', 0).

% By default, try to use XPRESS-MP 11 (student mode)
licence(_Default, xpress, '11', '', 0).
