% ----------------------------------------------------------------------
% System:	ECLiPSe Constraint Logic Programming System
% Copyright (C) Imperial College London and ICL 1995-1999
% Version:	$Id: numbervars.pl,v 1.2 1999/08/07 15:50:31 js10 Exp $
% ----------------------------------------------------------------------

%
% SEPIA PROLOG LIBRARY MODULE
%
% sccsid("%W%             %E%").
% sccscr("%Z%  Copyright 1991 ECRC GmbH ").
%
% IDENTIFICATION:       numbervars.pl
%
% AUTHOR:               Joachim Schimpf
%
% CONTENTS:             numbervars/3
%

:- module_interface(numbervars).

:- export numbervars/3.
:- set_flag(syntax_option, '$VAR').	% to print $VAR/1 terms as letters

:- begin_module(numbervars).

numbervars('$VAR'(N), N, N1) :- !,
	N1 is N + 1.
numbervars(Term, N, Next) :-
	functor(Term, _, Arity),
	numbervars(0, Arity, Term, N, Next).

numbervars(Arity, Arity, _, N, Next) :- !, N = Next.
numbervars(I, Arity, Term, N0, N) :-
	I1 is I + 1,
        arg(I1, Term, Arg),
        numbervars(Arg, N0, N1),
        numbervars(I1, Arity, Term, N1, N).

