% ----------------------------------------------------------------------
% System:	ECLiPSe Constraint Logic Programming System
% Copyright (C) Imperial College London and ICL 1995-1999
% Version:	$Id: oldio.pl,v 1.2 1999/08/07 15:50:32 js10 Exp $
% ----------------------------------------------------------------------

/*
 * SEPIA PROLOG SOURCE MODULE
 */

/*
 * sccsid("%W%		%E%").
 * sccscr("%Z%  Copyright 1989 ECRC GmbH ").
 */

/*
 * IDENTIFICATION:	oldio.pl
 *
 * DESCRIPTION: 	Contains built-in predicates to handle the I/O
 *			in the old BSI way, where the stream argument
 *			is the last one.
 *
 *
 * CONTENTS:     
 *
 * REVISION HISTORY:
 * AUTHOR	VERSION	DATE	REASON
 */

:- module_interface(oldio).
:- system.

:- begin_module(oldio).

:- export
	at/2,
	display/2,
	get/2,
	get0/2,
	get_char/2,
	print/2,
	put/2,
	put_char/2,
	read/2,
	readvar/3,
	rtoken/2,
	seek/2,
	tyi/2,
	tyo/2,
	write/2,
	writeclause/2,
	writeln/2,
	writeq/2.

:- import
	print_/3,
	read_/3,
	readvar/4,
	writeq_/3,
	write_/3
    from sepia_kernel.

% Tools
print_body(Term, S, M) :- print_(S, Term, M).

  readvar_body(Term, Var, S, M) :- readvar(S, Term, Var, M).

  read_body(Term, S, M) :- read_(S, Term, M).

write_body(Term, S, M) :- write_(S, Term, M).

writeq_body(Term, S, M) :- writeq_(S, Term, M).

% Others
at(P, S) :- call_explicit(at(S, P), sepia_kernel).

display(T, S) :- call_explicit(display(S, T), sepia_kernel).

get(X, S) :- call_explicit(get(S, X), sepia_kernel).

get0(X, S) :- call_explicit(get0(S, X), sepia_kernel).

get_char(X, S) :- call_explicit(get_char(S, X), sepia_kernel).

put(X, S) :- call_explicit(put(S, X), sepia_kernel).

put_char(X, S) :- call_explicit(put_char(S, X), sepia_kernel).

rtoken(Token, S) :- call_explicit(read_token(S, Token, _), sepia_kernel).

seek(O, S) :- call_explicit(seek(S, O), sepia_kernel).

tyi(X, S) :- call_explicit(tyi(S, X), sepia_kernel).

tyo(X, S) :- call_explicit(tyo(S, X), sepia_kernel).

writeclause(S, C) :- call_explicit(writeclause(C, S), sepia_kernel).

writeln(T, S) :- call_explicit(writeln(S, T), sepia_kernel).

:-  % must be after the bodies in order to inherit the system flag
    tool(print/2, print_body/3),
    tool(readvar/3, readvar_body/4),
    tool(read/2, read_body/3),
    tool(write/2, write_body/3),
    tool(writeq/2, writeq_body/3).

:- skipped
	at/2,
	display/2,
	get/2,
	get0/2,
	get_char/2,
	print/2,
	put/2,
	put_char/2,
	read/2,
	readvar/3,
	rtoken/2,
	seek/2,
	tyi/2,
	tyo/2,
	write/2,
	writeclause/2,
	writeln/2,
	writeq/2.

