% ----------------------------------------------------------------------
% System:	ECLiPSe Constraint Logic Programming System
% Copyright (C) Imperial College London and ICL 1997-1998
% Copyright (C) Parc Technologies Ltd 1999
% Version:	$Id: repairfd.pl,v 1.3 1999/08/07 14:56:40 js10 Exp $
%
%
% IDENTIFICATION:       repairfd.pl
%
% Contents:	CLP Repair example labeling
%
% Authors:	Hani El-Sakkout, Stefano Novello, Joachim Schimpf
%		IC-Parc
% ----------------------------------------------------------------------

% Example repair labeling strategy



% ----------------------------------------------------------------------
:- module_interface(repairfd).
% ----------------------------------------------------------------------

:- lib(fd).
:- lib(repair).
:- export repair/0.

% ----------------------------------------------------------------------
:- begin_module(repairfd).
% ----------------------------------------------------------------------

repair :-
	( conflict_vars([C|_onflict]) ->
		indomain(C),
		repair
	; conflict_constraints([C|_onflictConstraints]) ->
		term_variables(C, Vars),
		deleteffc(Var,Vars, _),
		Var tent_get Val,
		(Var = Val ; Var #\= Val), % choice
		repair
	;
		true
	).
