/*
 *	$Header: /homes/js10/eclipse_home/Cvsroot/Eclipse/Opium/opiumtop.pl,v 1.1 1998/10/28 11:53:34 js10 Exp $
 *	1990 Copyright ECRC GmbH
 */

/* 
 *   bootstrapping of Opium scenarios in module opium
 *   (loadfile is loadopium.pl)
 */

:- module(opium_kernel).

:- import extension/1 from sepia_kernel.
:- global get_opium_file/2.	/* for manual/1 */

:- (extension(development) ->
	make_local_array(opiumdir),
	getcwd(D),
	setval(opiumdir, D),
	compile_term([
	    get_opiumdir(D) :-
		    getval(opiumdir, D)
	])
   ;
	(import get_opiumdir/1 from sepia_kernel)
   ).

/* 
 *  get_opium_file(+File, -OpFile)
 *  determines full name of File according to opiumdir
 */
get_opium_file(File, OpFile) :-
	get_opiumdir(Dir),
	get_op_file(File, Dir, OpFile).

get_op_file(File, Dir, OpFile) :-
	concat_string([Dir, "/", File], OpFile),
	exists(OpFile),
	!.
get_op_file(File, Dir, OpFile) :-
	get_flag(prolog_suffix, Suff),
	member(S, Suff),
	concat_string([Dir, "/", File, S], OpFile),
	exists(OpFile),
	!.

/*
 *  compile Opium loadfile
 */

/*  to avoid that file is dumped in compiled query
 */
mycompile(F) :-
	compile(F).

:- argv(5, LoadF),
   get_opium_file(LoadF, LoadFile), 
   mycompile(LoadFile).










	


